package exceptii;

import java.util.Collection;

/**
 * 
 * @author daniel
 *
 */
public class Calculator {

	static class OverflowException extends RuntimeException {
		private static final long serialVersionUID = 7095559223385465726L;
	}
	
	static class UnderflowException extends RuntimeException {
		private static final long serialVersionUID = -5699783230134990472L;
	}
	
	static class DivisionByZeroException extends RuntimeException {
		private static final long serialVersionUID = 1L;
	}
	
	/**
	 * Adunarea a doua numere int. Observati conditiile de exceptie. De exemplu,
	 * se produce overflow daca se depaseste Integer.MAX_VALUE, adica
	 * 0111...1 (31 de biti 1), deci se ajunge la 1xxxx...x (in domeniul negativ).
	 * 
	 * @param a
	 * @param b
	 * @return
	 */
	public int add(int a, int b) {
		int sum = a + b;
		
		if (a > 0 && b > 0 && sum < 0)
			throw new OverflowException();
		
		if (a < 0 && b < 0 && sum > 0)
			throw new UnderflowException();
		
		return sum;
	}
	
	/**
	 * Impartire intreaga a doi intregi. Se arunca o exceptie la impartirea la zero.
	 * @param a
	 * @param b
	 * @return
	 */
	public int divide (int a, int b) {
		if (b == 0)
			throw new DivisionByZeroException();
		
		return a/b;
	}
	
	/**
	 * Media (intreaga) a unei colectii de intregi. Se folosesc functiile 
	 * <code>add</code> si <code>divide</code>, care arunca exceptii.
	 * @param collection
	 * @return
	 */
	public int average (Collection <Integer> collection) {
		int sum = 0;
		int n = collection.size();

		// n-are rost sa arunc exceptie la o colectie goala, cand ii stiu media
		if (n == 0)
			return 0;
		
		for (Integer i : collection)
			sum = add(sum, i);
		
		return divide(sum,n);
	}
}
